#ifdef GL_ES
precision highp float;
#endif

uniform mediump vec4 u_screenSize;
uniform mediump sampler2D u_texture; // Diffuse
uniform mediump sampler2D u_texture1; // Mask
uniform mediump sampler2D u_texture2; // Normal
varying mediump vec2 v_texCoord;
varying mediump vec4 v_color;

varying mediump vec3 v_normal;
varying mediump vec3 v_tangent; //NOT WORKING
varying mediump vec3 v_binormal;

varying mediump vec3 v_camDir;
varying mediump vec3 v_camPos;
varying mediump vec3 v_lightDir;
varying mediump vec3 v_viewVector;

uniform mediump vec4 u_color4;
uniform mediump vec4 u_materialAmbient;
uniform mediump vec4 u_materialDiffuse;
uniform mediump vec4 u_materialEmissive;
uniform mediump vec4 u_materialSpecular;
uniform mediump float u_materialShininess;

uniform highp vec4 lighting_settings;
uniform highp vec4 texture_settings;

/*
mediump mat3 cotangent_frame(mediump vec3 N, mediump vec3 p, mediump vec2 uv) {
    // get edge vectors of the pixel triangle
    mediump vec3 dp1 = dFdx( p );
    mediump vec3 dp2 = dFdy( p );
    mediump vec2 duv1 = dFdx( uv );
    mediump vec2 duv2 = dFdy( uv );
 
    // solve the linear system
    mediump vec3 dp2perp = cross( dp2, N );
    mediump vec3 dp1perp = cross( N, dp1 );
    mediump vec3 T = dp2perp * duv1.x + dp1perp * duv2.x;
    mediump vec3 B = dp2perp * duv1.y + dp1perp * duv2.y;
 
    // construct a scale-invariant frame 
    mediump float invmax = inversesqrt( max( dot(T,T), dot(B,B) ) );
    return mat3( T * invmax, B * invmax, N );
}

mediump vec3 perturb_normal(mediump vec3 N, mediump vec3 V, mediump vec2 texcoord) {
    // assume N, the interpolated vertex normal and 
    // V, the view vector (vertex to eye)
    mediump vec3 map = texture2D( u_texture2, texcoord ).xyz * 2.0 - 1.0;
	map = mix( vec3(0.0, 0.0, 1.0), map, clamp(v_color.xyz*texture_settings.z,0.0,1.0));


    mediump mat3 TBN = cotangent_frame( N, -V, texcoord );
    return normalize( TBN * map );
}
*/

void main() {
	mediump vec4 baseColor = texture2D(u_texture, v_texCoord * texture_settings.w);
	mediump float mask = texture2D(u_texture1, v_texCoord * texture_settings.x).b;
	//mediump vec3 normalmap = texture2D(u_texture2, v_texCoord * texture_settings.y).xyz * 2.0 - 1.0;

	mediump vec3 normalmap = vec3(0.0, 0.0, 1.0);

	mediump vec3 L = normalize(v_lightDir);
	mediump vec3 CD = normalize(v_camDir);
	mediump vec3 N = normalize(v_normal);
	mediump vec3 T = normalize(v_tangent);
	mediump vec3 B = normalize(v_binormal);
	mediump vec3 V = normalize(v_viewVector);
	
	// Normal mapping

	normalmap = mix( vec3(0.0, 0.0, 1.0), normalmap, clamp(v_color.xyz*texture_settings.z,0.0,1.0));

	mediump mat3 TBN = mat3(T, B, N);
	mediump vec3 Nm = normalize(TBN * normalmap);
	//EVIL
	//mediump vec3 Nm = perturb_normal( N, V, v_texCoord * texture_settings.y);

	



	mediump vec4 maskedColor = mix(vec4(1,1,1,1), v_color, mask);
	mediump vec4 borderColor = u_materialDiffuse;


	mediump float diffuseWrap = lighting_settings.x; //

	mediump vec4 ret = vec4(0.0, 0.0, 0.0, 1.0);


	mediump float diffuse = clamp( ( dot(L, Nm) + diffuseWrap ) / ( 1.0 + diffuseWrap ),lighting_settings.y,1.0 );


	//deafult should be x = 0.8, y = 0.1 Used to push the border as well as solidify it
	mediump float boost = pow(v_color.r, 0.8)+0.1;
	mediump vec4 albedo = mix( borderColor, u_color4, maskedColor * boost );
	albedo = baseColor * albedo; 

	mediump vec4 diffuseColor = albedo * (diffuse + u_materialAmbient);
	mediump float specularGlossiness = u_materialShininess;
	mediump vec4 specularColor = vec4(1.0, 1.0, 1.0, 1.0);
	mediump vec4 lightColor = vec4(1.0, 1.0, 1.0, 1.0);
	mediump float gloss = float(1.0);
	specularColor = u_materialSpecular;
	mediump vec3 H = normalize(L + CD);
	mediump float NdotH = clamp(dot(Nm, H), 0.0, 1.0);

	specularColor = specularColor * pow(NdotH, specularGlossiness);

	ret = ret + specularColor;
	ret = ret + diffuseColor;
	ret = ret * lightColor;
	gl_FragColor = ret;
	gl_FragColor.a = 1.0;

}