#ifdef GL_ES
precision highp float;
#endif

uniform mediump mat4 u_modelViewMatrix;
uniform mediump mat4 u_modelViewProjectionMatrix;
uniform mediump mat4 u_modelMatrix;
uniform mediump mat4 u_viewMatrix;
uniform mediump mat4 u_projectionMatrix;

uniform highp float u_time;
uniform mediump sampler2D u_texture1; // Mask

attribute mediump vec4 a_position;

attribute mediump vec4 a_color;
varying mediump vec4 v_color;

attribute mediump vec2 a_texCoord;
varying mediump vec2 v_texCoord;

attribute mediump vec3 a_normal;
varying mediump vec3 v_normal;
varying mediump vec3 v_tangent;
varying mediump vec3 v_binormal;

varying mediump vec3 v_camDir;
varying mediump vec3 v_camPos;

uniform mediump vec4 u_materialEmissive; // Light Direction
varying mediump vec3 v_lightDir;
varying mediump vec3 v_viewVector;


uniform highp vec4 u_data1; // x=speed, y=offset_multiplier


void main() {
	//v_normal = (u_modelMatrix * vec4(a_normal, 0.0)).xyz;
	v_normal = normalize((u_modelViewMatrix * vec4(a_normal, 0.0)).xyz);
	
	//v_tangent = normalize(a_color.xyz);
	//v_tangent = a_color.xyz;
	//v_binormal = normalize(cross(v_normal, v_tangent));
	
	/*
	vec3 c1 = cross(v_normal, vec3(0.0, 0.0, 1.0));
	vec3 c2 = cross(v_normal, vec3(0.0, 1.0, 0.0));
	if (length(c1) > length(c2)) {
		v_tangent = c1;
	} else {
		v_tangent = c2;
	}
	v_tangent = normalize(v_tangent);
	v_binormal = normalize(cross(v_normal, v_tangent));
	*/

	v_tangent = normalize(cross(v_normal, vec3(0.0, -1.0, 0.0)));
	v_binormal = normalize(cross(v_normal, v_tangent));

	v_lightDir = normalize((vec4(u_materialEmissive.xyz * 2.0 - 1.0, 0.0)).xyz);
	
	//float r = texture2D(u_texture1, a_texCoord + u_time * u_data1.x).r * u_data1.y;
	//vec4 offset = vec4(a_normal, 0.0) * r;
	
	v_camDir = vec3(u_viewMatrix[2]);
	v_camPos = vec3(u_viewMatrix[3]);

	gl_Position = u_modelViewProjectionMatrix * a_position;

	v_color = a_color;
	v_texCoord = a_texCoord;
	v_viewVector = v_camPos - gl_Position.xyz;
}