uniform mediump sampler2D u_texture;
uniform mediump sampler2D u_texture1;
uniform mediump vec4 u_screenSize;
uniform mediump vec4 u_color4;
uniform mediump float u_time;

varying mediump vec2 v_texCoord;
varying mediump vec3 v_camDir;
varying mediump vec4 v_color;

varying mediump vec3 v_normal;
varying mediump vec3 v_tangent;
varying mediump vec3 v_binormal;

varying mediump vec3 v_camPos;
varying mediump vec3 v_lightDir;
varying mediump vec3 v_viewVector;

uniform mediump vec4 u_materialAmbient;
uniform mediump vec4 u_materialDiffuse;
uniform mediump vec4 u_materialSpecular;
uniform mediump vec4 u_materialEmissive;
uniform mediump float u_materialShininess;

uniform highp vec4 u_data1;
uniform highp vec4 u_data2;

void main() {
	/*
	mediump vec3 N = normalize(v_normal);
	mediump vec3 CD = normalize(v_camDir);
	
	mediump vec4 color = texture2D(u_texture, v_texCoord);
	
	//gl_FragColor = color + (1.0 - clamp(pow(dot(N, CD) * u_data.y, u_data.x), 0.0, 1.0));
	gl_FragColor = clamp(color + u_color4 * (1.0 - clamp(pow(dot(N, CD) * u_data1.y, u_data1.x), 0.0, 1.0)), 0.0, 1.0);
	*/

	/*
	mediump vec4 color = texture2D(u_texture, v_texCoord * u_data1.z);
	const mediump vec3 normalmap = vec3(0.0, 0.0, 1.0);
	
	mediump vec3 L = normalize(v_lightDir);
	mediump vec3 CD = normalize(v_camDir);
	mediump vec3 N = normalize(v_normal);
	mediump vec3 T = normalize(v_tangent);
	mediump vec3 B = normalize(v_binormal);
	
	// Normal mapping
	mediump mat3 TBN = mat3(T, B, N);
	mediump vec3 Nm = normalize(TBN * normalmap);

	mediump float nDotL = clamp(dot(Nm, L), u_data1.w, 1.0);
	mediump float diffuse = nDotL;
	mediump float specular = pow(nDotL, u_materialShininess);

	gl_FragColor = color;
	gl_FragColor.rgb = gl_FragColor.rgb * (u_materialDiffuse * diffuse + u_materialAmbient).rgb + u_materialSpecular.rgb * specular;
	gl_FragColor.rgb = gl_FragColor.rgb * vec3(u_materialAmbient.a, u_materialAmbient.a, u_materialAmbient.a);
	gl_FragColor.rgb += clamp((1.0 - clamp(pow(dot(N, CD) * u_data1.y, u_data1.x), 0.0, 1.0)), 0.0, 1.0);
	gl_FragColor = gl_FragColor * u_color4;
	*/

	mediump vec3 N = normalize(v_normal);
	mediump vec3 CD = normalize(v_camDir);

	mediump vec2 mask = texture2D(u_texture1, v_texCoord * u_data2.x).rg;
	mediump vec4 base = vec4(mask.x, mask.x, mask.x, 1.0);
	mediump vec4 caustics = vec4(mask.y, mask.y, mask.y, 1.0) * u_data2.y;
	base = mix(u_materialDiffuse, base, mask.x);
	base = mix(vec4(1.0, 1.0, 1.0, 1.0), base, v_color);
	base += u_data2.z;
	base *= u_color4;
	base += caustics;

	gl_FragColor = base;
	gl_FragColor.rgb += clamp((1.0 - clamp(pow(dot(N, CD) * u_data1.y, u_data1.x), 0.0, 1.0)), 0.0, 1.0);
}