uniform mediump mat4 u_viewMatrix;
uniform mediump mat4 u_modelViewMatrix;
uniform mediump mat4 u_modelViewProjectionMatrix;

attribute mediump vec4 a_position;

attribute mediump vec2 a_texCoord;
varying mediump vec2 v_texCoord;

attribute mediump vec4 a_color;
varying mediump vec4 v_color;

attribute mediump vec3 a_normal;
varying mediump vec3 v_normal;
varying mediump vec3 v_tangent;
varying mediump vec3 v_binormal;

varying mediump vec3 v_camDir;
varying mediump vec3 v_camPos;
varying mediump vec3 v_viewVector;

uniform mediump vec4 u_materialEmissive; // Light Direction
varying mediump vec3 v_lightDir;


void main() {
	gl_Position = u_modelViewProjectionMatrix * a_position;
	
	v_normal = (u_modelViewMatrix * vec4(a_normal, 0.0)).xyz;
	v_tangent = normalize(cross(v_normal, vec3(0.0, -1.0, 0.0)));
	v_binormal = normalize(cross(v_normal, v_tangent));
	
	v_texCoord = a_texCoord;

	v_lightDir = normalize((vec4(u_materialEmissive.xyz * 2.0 - 1.0, 0.0)).xyz);

	v_camDir = vec3(u_viewMatrix[2]);
	v_camPos = vec3(u_viewMatrix[3]);

	v_texCoord = a_texCoord;
	v_viewVector = v_camPos - gl_Position.xyz;
	v_color = a_color;
}