uniform sampler2D u_texture;
uniform lowp vec4 u_materialAmbient;

varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;
varying lowp float v_rotatedTexCoord;

void main() {
	vec4 baseColor = texture2D(u_texture, v_texCoord);
	
	float size = u_materialAmbient.r * 1024.0;
	float isStripe = floor(v_rotatedTexCoord * size);

	gl_FragColor = mix(baseColor, mix(baseColor, vec4(v_color.rgb, 1.0), v_color.a), mod(isStripe, 2.0));
	gl_FragColor.a = baseColor.a;
}