// Map 128 to PI (180 degrees, Using the Shininess parameter)
#define MAP_TO_PI 1.0 * 3.1415926 * 0.0078125

uniform lowp mat4 u_modelViewProjectionMatrix;
uniform lowp float u_materialShininess;

attribute lowp vec4 a_position;
attribute lowp vec4 a_color;
attribute lowp vec2 a_texCoord;

varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;
varying lowp float v_rotatedTexCoord;

void main() {
	gl_Position = u_modelViewProjectionMatrix * a_position;
	
	v_color = a_color;
	v_texCoord = a_texCoord;

	float rotation = u_materialShininess * MAP_TO_PI;

	float cU = a_texCoord.x - 0.5;
	float cV = a_texCoord.y - 0.5;
	float newU = cU * cos(rotation) - cV * sin(rotation) + 0.5;
	//float newU = cU * cos(rotation) - cV * sin(rotation);
	//float newV = cU * sin(rotation) + V * cos(rotation);
	//v_rotatedTexCoord = vec2(newU + 0.5f, newV + 0.5f);
	v_rotatedTexCoord = newU;
}